package com.ventasZ.model;
// Generated 01-03-2020 09:20:46 AM by Hibernate Tools 4.3.1

import java.util.ArrayList;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import static javax.persistence.GenerationType.IDENTITY;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 * Producto generated by hbm2java
 */
@Entity
@Table(name = "producto",
         catalog = "ventas"
)
public class Producto implements java.io.Serializable {

    private Integer idProducto;
    private Categoria categoria;
    private String nombre;
    private double precio;
    private int stock;
    private List<Detalle> detalles = new ArrayList<Detalle>();

    public Producto() {
    }

    public Producto(Categoria categoria, String nombre, double precio, int stock) {
        this.categoria = categoria;
        this.nombre = nombre;
        this.precio = precio;
        this.stock = stock;
    }

    public Producto(Categoria categoria, String nombre, double precio, int stock, List<Detalle> detalles) {
        this.categoria = categoria;
        this.nombre = nombre;
        this.precio = precio;
        this.stock = stock;
        this.detalles = detalles;
    }

    @Id
    @GeneratedValue(strategy = IDENTITY)

    @Column(name = "id_producto", unique = true, nullable = false)
    public Integer getIdProducto() {
        return this.idProducto;
    }

    public void setIdProducto(Integer idProducto) {
        this.idProducto = idProducto;
    }

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "id_categoria", nullable = false)
    public Categoria getCategoria() {
        return this.categoria;
    }

    public void setCategoria(Categoria categoria) {
        this.categoria = categoria;
    }

    @Column(name = "nombre", nullable = false, length = 150)
    public String getNombre() {
        return this.nombre;
    }

    public void setNombre(String nombre) {
        this.nombre = nombre;
    }

    @Column(name = "precio", nullable = false, precision = 5, scale = 0)
    public double getPrecio() {
        return this.precio;
    }

    public void setPrecio(double precio) {
        this.precio = precio;
    }

    @Column(name = "stock", nullable = false)
    public int getStock() {
        return this.stock;
    }

    public void setStock(int stock) {
        this.stock = stock;
    }

    @OneToMany(fetch = FetchType.LAZY, mappedBy = "producto")

    public List<Detalle> getDetalles() {
        return detalles;
    }

    public void setDetalles(List<Detalle> detalles) {
        this.detalles = detalles;
    }

}
